// Plik matrix_keyboard.v
module MatrixKeyboard(
  input Clock,
  input Reset,
  input [7:0] Cathodes,
  input [3:0] Rows,
  output KeyStrobe,
  output reg KeyPressed,
  output reg [4:0] KeyCode
);

  // Bufor wszystkich przyciskw
  reg [31:0] KeyBuffer;
  
  // Kopiowanie wejcia Rows do odpowiedniej pozycji w buforze
  always @(posedge Clock, negedge Reset) begin
    if(!Reset)
      KeyBuffer <= 0;
    else begin
      if(Cathodes[0]) KeyBuffer[ 3: 0] <= Rows[3:0];
      if(Cathodes[1]) KeyBuffer[ 7: 4] <= Rows[3:0];
      if(Cathodes[2]) KeyBuffer[11: 8] <= Rows[3:0];
      if(Cathodes[3]) KeyBuffer[15:12] <= Rows[3:0];
      if(Cathodes[4]) KeyBuffer[19:16] <= Rows[3:0];
      if(Cathodes[5]) KeyBuffer[23:20] <= Rows[3:0];
      if(Cathodes[6]) KeyBuffer[27:24] <= Rows[3:0];
      if(Cathodes[7]) KeyBuffer[31:28] <= Rows[3:0];
    end
  end
    
  // Analizowanie bufora
  // Ustalanie czy wcinito przycisk i jaki jest jego kod
  always @(posedge Clock, negedge Reset) begin
    if(!Reset) begin
      KeyCode    <= 0;
      KeyPressed <= 0;
    end else begin
      if(KeyBuffer[0])        begin KeyCode <= 5'd0;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[1])   begin KeyCode <= 5'd1;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[2])   begin KeyCode <= 5'd2;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[3])   begin KeyCode <= 5'd3;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[4])   begin KeyCode <= 5'd4;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[5])   begin KeyCode <= 5'd5;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[6])   begin KeyCode <= 5'd6;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[7])   begin KeyCode <= 5'd7;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[8])   begin KeyCode <= 5'd8;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[9])   begin KeyCode <= 5'd9;  KeyPressed <= 1'b1; end
      else if(KeyBuffer[10])  begin KeyCode <= 5'd10; KeyPressed <= 1'b1; end
      else if(KeyBuffer[11])  begin KeyCode <= 5'd11; KeyPressed <= 1'b1; end
      else if(KeyBuffer[12])  begin KeyCode <= 5'd12; KeyPressed <= 1'b1; end
      else if(KeyBuffer[13])  begin KeyCode <= 5'd13; KeyPressed <= 1'b1; end
      else if(KeyBuffer[14])  begin KeyCode <= 5'd14; KeyPressed <= 1'b1; end
      else if(KeyBuffer[15])  begin KeyCode <= 5'd15; KeyPressed <= 1'b1; end
      else if(KeyBuffer[16])  begin KeyCode <= 5'd16; KeyPressed <= 1'b1; end
      else if(KeyBuffer[17])  begin KeyCode <= 5'd17; KeyPressed <= 1'b1; end
      else if(KeyBuffer[18])  begin KeyCode <= 5'd18; KeyPressed <= 1'b1; end
      else if(KeyBuffer[19])  begin KeyCode <= 5'd19; KeyPressed <= 1'b1; end
      else if(KeyBuffer[20])  begin KeyCode <= 5'd20; KeyPressed <= 1'b1; end
      else if(KeyBuffer[21])  begin KeyCode <= 5'd21; KeyPressed <= 1'b1; end
      else if(KeyBuffer[22])  begin KeyCode <= 5'd22; KeyPressed <= 1'b1; end
      else if(KeyBuffer[23])  begin KeyCode <= 5'd23; KeyPressed <= 1'b1; end
      else if(KeyBuffer[24])  begin KeyCode <= 5'd24; KeyPressed <= 1'b1; end
      else if(KeyBuffer[25])  begin KeyCode <= 5'd25; KeyPressed <= 1'b1; end
      else if(KeyBuffer[26])  begin KeyCode <= 5'd26; KeyPressed <= 1'b1; end
      else if(KeyBuffer[27])  begin KeyCode <= 5'd27; KeyPressed <= 1'b1; end
      else if(KeyBuffer[28])  begin KeyCode <= 5'd28; KeyPressed <= 1'b1; end
      else if(KeyBuffer[29])  begin KeyCode <= 5'd29; KeyPressed <= 1'b1; end
      else if(KeyBuffer[30])  begin KeyCode <= 5'd30; KeyPressed <= 1'b1; end
      else if(KeyBuffer[31])  begin KeyCode <= 5'd31; KeyPressed <= 1'b1; end
      else KeyPressed <= 1'b0;
    end
  end
  
  // Wykrywanie zbocza rosncego na KeyPressed
  reg KeyPressedPrevious;
  always @(posedge Clock, negedge Reset) begin
    if(!Reset)
      KeyPressedPrevious <= 0;
    else
      KeyPressedPrevious <= KeyPressed;
  end
  
  assign KeyStrobe = !KeyPressedPrevious && KeyPressed;

endmodule
